﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

#SingleInstance,Force
#Persistent

Gui +LastFound
hWnd := WinExist()

Menu, Tray, Icon, icon.ico

global oscTypeFloat := 4
global MODPort

inifilename := "State File Mod v2 - Database.ini"

if not FileExist(inifilename)
	FileAppend, [DeletingString]`nkey=_delfromstate`n[OpenStagePort]`nip=127.0.0.1`nport=5001`n[MODPort]`nport=5003`n, %inifilename%

IniRead, deletingstring, %inifilename%, DeletingString, key, NULL
IniRead, ip, %inifilename%, OpenStagePort, ip, NULL
IniRead, OpenStagePort, %inifilename%, OpenStagePort, port, NULL
IniRead, MODPort, %inifilename%, MODPort, port, NULL


DllCall("LoadLibrary", "Str", "x64\Debug\OSC2AHK.dll", "Ptr")

success := DllCall("OSC2AHK.dll\open", UInt, hWnd, UInt, 5003)  ; ########### RECEIVING PORT ############# 
if (success != 0)
	msgbox, Failed to open port!

DllCall("OSC2AHK.dll\addListener", AStr, "/checkfiles", UInt, 0x1002, UInt, oscTypeFloat)  ; ############ check message ##########
OnMessage(0x1002, "msghandlerFloat")

OnExit("ExitFunc")

return

ExitFunc()
{
	DllCall("OSC2AHK.dll\close", UInt, MODPort)	;closing the port when exiting
}

CheckFiles:

Loop,Files, %A_ScriptDir%\*.state, R
{
	FileGetTime, TimeModified, %A_LoopFileLongPath%, M
	
	IniRead, LastTimeModified, %inifilename%, StateFilesLastTimeModified, %A_LoopFileName%, NULL
	
	if (LastTimeModified = "NULL")
	{
		IniWrite, %TimeModified%, %inifilename%, StateFilesLastTimeModified, %A_LoopFileName%
	}
	
	if (TimeModified > LastTimeModified or LastTimeModified = "NULL")
	{
		ProcessFile:
		
		RemovedLines := 0
		
		Loop, Read, %A_LoopFileLongPath%, %A_LoopFileLongPath%.temp
		{
			if not InStr(A_LoopReadLine, deletingstring)
				FileAppend, %A_LoopReadLine%`n
			else
				RemovedLines += 1
		}
		
		FileMove, %A_LoopFileLongPath%.temp, %A_LoopFileLongPath%, 1
		FileDelete, %A_LoopFileLongPath%.temp
		
		FileGetTime, TimeModified, %A_LoopFileLongPath%, M
		
		IniWrite, %TimeModified%, %inifilename%, StateFilesLastTimeModified, %A_LoopFileName%
		
		addr := "/NOTIFY"
		data := RemovedLines . " widgets removed from the state file."
		
		DllCall("OSC2AHK.dll\sendOscMessageString", AStr, ip, UInt, OpenStagePort, AStr, addr, AStr, data)
	}
	
	FileRead, FileProcessed, %A_LoopFileLongPath%
	
	LastCommaDeleted := StrReplace(FileProcessed, ",`r`n}", "`r`n}", ReplaceCount)
	
	if (ReplaceCount)
	{
		FileDelete, %A_LoopFileLongPath%
		FileAppend, %LastCommaDeleted%, %A_LoopFileLongPath%
		ReplaceCount := ""
	}
	
}

return



msghandlerFloat(wParam, lParam, msg, hwnd) {
    ; Check if we actually got a float
	;if (wParam != 4)
		;return
	
    ; Retrieve float from the lParam
	/*
		VarSetCapacity(buf, 8, 0)
		NumPut(lParam, buf)
		Value := NumGet(buf, "Float")
	*/
	SetTimer,checkfiles, -100
	Gosub, CheckFiles
}

